
/* Chrysalide - Outil d'analyse de fichiers binaires
 * wide.h - prototypes pour la bascule de texte ASCII en UTF-16
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_ITEMS_STRING_WIDE_H
#define _ANALYSIS_SCAN_ITEMS_STRING_WIDE_H


#include <glib-object.h>


#include "../../item.h"



#define G_TYPE_SCAN_STRING_WIDE_FUNCTION            g_scan_string_wide_function_get_type()
#define G_SCAN_STRING_WIDE_FUNCTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_SCAN_STRING_WIDE_FUNCTION, GScanStringWideFunction))
#define G_IS_SCAN_STRING_WIDE_FUNCTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_SCAN_STRING_WIDE_FUNCTION))
#define G_SCAN_STRING_WIDE_FUNCTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_SCAN_STRING_WIDE_FUNCTION, GScanStringWideFunctionClass))
#define G_IS_SCAN_STRING_WIDE_FUNCTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_SCAN_STRING_WIDE_FUNCTION))
#define G_SCAN_STRING_WIDE_FUNCTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_SCAN_STRING_WIDE_FUNCTION, GScanStringWideFunctionClass))


/* Bascule d'une suite de texte ASCII en UTF-16 (instance) */
typedef GScanRegisteredItem GScanStringWideFunction;

/* Bascule d'une suite de texte ASCII en UTF-16 (classe) */
typedef GScanRegisteredItemClass GScanStringWideFunctionClass;


/* Indique le type défini pour une bascule de texte ASCII en UTF-16. */
GType g_scan_string_wide_function_get_type(void);

/* Constitue une fonction de bascule de texte ASCII en UTF-16. */
GScanRegisteredItem *g_scan_string_wide_function_new(void);



#endif  /* _ANALYSIS_SCAN_ITEMS_STRING_WIDE_H */
